
#ifndef _NTPEDITCTRL_H_
#define _NTPEDITCTRL_H_

#include "doc.h"
#include "view.h"

namespace ntpedit{

//@{
// GfBbgRg[NXB
// ꂪ doc  view ЂƂÂĂB
// view ɂȂ邱Ƃ͂ĂAdoc 
// ɂЂƂB
//@}
class NtpEdit : public Window
{
public:
	NtpEdit();
	~NtpEdit();

public:
	Doc& getDoc();
	View& getView();
	PaintTool& getPaintTool();

private:
	void onCreate();
	void onDestroy();
	LRESULT onMessage( UINT msg, WPARAM wp, LPARAM lp );

private:
	auto_ptr<Doc>  _doc;
	auto_ptr<View> _view;
//	Doc*  _doc;
//	View* _view;
};

//--------------------------------------------
inline Doc& NtpEdit::getDoc()
{ return *_doc; }

inline View& NtpEdit::getView()
{ return *_view; }

inline PaintTool& NtpEdit::getPaintTool()
{ return _view->getPaintTool(); }

} //namespace ntpedit
#endif
