
#include "ntpedit.h"

#include "painter.h"

using namespace ntpedit;

int Painter::_bstart;
bool Painter::_endcmt = false;

extern void setMessage(LPCTSTR m);

//------------------------------------------------
// Painter NX̃\bĥA
// {IȂ̂͂ɁB
// L[[h֘AƂ painter2.cppɁB
//------------------------------------------------

Painter::Painter(Doc& d, PaintTool& t, HWND h)
	: BasePainter()
	,_doc(d), _tool(t), _vwnd(h)
{
	_bstart = 0;
	::SetBkMode( _tool.getDC(), TRANSPARENT );
//	::SetMapMode( _tool.getDC(), MM_TEXT );
}

//----------------------------------------------------------------
Painter::~Painter()
{}

//----------------------------------------------------------------
void Painter::onSize( int height, int width )
{}

//----------------------------------------------------------------
void Painter::onPaint( PAINTSTRUCT *pps, int start, int hscroll )
{
	RECT r, ur, cr, tar;
	int y, nstart, ui;

	_tool.getClientRect(&cr);
	_tool.getTextAreaRect(&tar);
	cr.bottom = tar.bottom;

	r = pps->rcPaint;

#ifdef DEBUG
	TCHAR temp[128];
	wsprintf(temp, _T("Painter::onPaint : TOP:%d BOTTOM:%d"),
		r.top, r.bottom);
	setMessage(temp);
#endif

	// ȂS`
	if( r.left != cr.left ){
		ur = cr, y=0, nstart=start;
		goto DRAWALL;
	}
	// X^[gʒuƂ
	if( _bstart == start ){
		if( r.top==0 )
			ur = r, y=0, nstart=start;
		else
		{
			int lw  = _tool.getFontHeight() + _tool.getLineSpace();
			nstart=start+r.top/lw;
			ur = r, y=0;
		}
		goto DRAWALL;
	}

	// _bstart  start rāA
	// ScrollWindowEx ōςޗ̈
	y = (_bstart - start)*
		( _tool.getFontHeight()+_tool.getLineSpace() );

	// XN[
	// Ō̈ SW_ERASE Ƃ SW_INVALIDATE ƂB
	ScrollWindowEx( _vwnd, 0, y, NULL, &r, NULL, &ur, 0 );

	// sڂ`Kv̂
	if( _bstart - start < 0 ){
		nstart = _bstart + _tool.getLines();

		int lheight = _tool.getFontHeight()+_tool.getLineSpace();
/*		// XN[o[Ƃp
#ifdef _WIN32_WCE
		if( cr.bottom/lheight != _tool.getLines() 
			&& (ur.bottom-ur.top)%lheight==0 )
			nstart++;
#else
		if( cr.bottom/lheight != _tool.getLines()
			&& (cr.bottom-cr.top)%lheight==lheight-1 )
			nstart++;
#endif
*/
		// XN[o[ȂƂp
#ifdef _WIN32_WCE
//		if( cr.bottom/lheight != _tool.getLines() 
//			&& (ur.bottom-ur.top)%lheight==0 )
//			nstart++;
#else
//		if( cr.bottom/lheight != _tool.getLines() )
//			nstart--;
#endif
	}else{
		nstart = start;
	}
	// `悵ȂȂc̕`

	// ur ̈ʒu
	ui = ur.top%_tool.getFontHeight()+_tool.getLineSpace();
	ur.top = ui>=0 ? 
		ur.top-ui : 
		ur.top-ui+_tool.getFontHeight()+_tool.getLineSpace();

DRAWALL:
	// ͈͑I̍ĕ`̉\̂
	// ̕ӂ RECT ̍ĒKvH

	// memory DC ̍쐬
	// `̂т CompatibleBitmap ̑傫
	// Ⴄ̂ˁ[
	HDC hdc = _tool.getDC();
	HDC memdc = ::CreateCompatibleDC(hdc);
	HBITMAP bmp = ::CreateCompatibleBitmap( hdc,
		ur.right-ur.left, ur.bottom-ur.top );
	HBITMAP oldbmp = (HBITMAP)::SelectObject( memdc, bmp );
	LOGFONT& lf = _tool.getFont();
	HFONT f = ::CreateFontIndirect( &lf );
	HFONT oldf = (HFONT)::SelectObject( memdc, f );

	// wihH
	drawBackground( memdc, &ur );

	// sԍGA`H
	drawLinenumArea( memdc );

	// `H
	drawText( memdc, nstart, &ur, hscroll );

	// ]
	::BitBlt(hdc,
		ur.left, ur.top,
		ur.right, ur.bottom,
		memdc, 0, 0, SRCCOPY);

	::SelectObject( memdc, oldf );

	::DeleteObject( f );
	::SelectObject(memdc, oldbmp);
	::DeleteObject(bmp);
	::DeleteDC(memdc);

	_bstart = start;
}

//----------------------------------------------------------------
void Painter::drawBackground( HDC hdc, LPRECT r )
{
	HBRUSH hBrush = ::CreateSolidBrush( _tool.getColor(PaintTool::BG) );
	RECT client = { 0, 0, r->right-r->left, r->bottom-r->top };
	::FillRect(hdc, &client, hBrush);
	::DeleteObject(hBrush);
}

//----------------------------------------------------------------
void Painter::drawLinenumArea( HDC hdc )
{
	// Oɍsԍ`Ȃ_H

	// 
	RECT LNArea;
	_tool.getLineNumRect(&LNArea);

	// ̈悪ȂȂ珑Ȃ
	if( LNArea.right == 0 ) return;

	HPEN hPen, hOldPen;
	LOGPEN lp={0};
	lp.lopnStyle = PS_SOLID;
	lp.lopnColor = _tool.getColor( PaintTool::TXT );
	hPen = ::CreatePenIndirect(&lp);

	hOldPen = (HPEN)::SelectObject(hdc, hPen);
	POINT pt[2]={LNArea.right-1, 0, LNArea.right-1, LNArea.bottom};
	::Polyline(hdc, pt, 2);
    ::SelectObject(hdc, hOldPen);
	::DeleteObject(hPen);
}

//----------------------------------------------------------------
void Painter::drawText( HDC hdc, int start, LPRECT cr, int hscroll )
{
	size_t size = _doc.getStringSize();
	int     ls = _tool.getLineSpace();
	int height = _tool.getFontHeight();
	RECT r;
	_tool.getTextAreaRect( &r );
	r.bottom = cr->bottom - cr->top;

	// X^[gʒu߂
	UINT startStr=0;
	UINT startLine=0;
	for( UINT k=0, p=0; k<(UINT)start, k<size; k++)
	{
		const LineInfo& f = _tool.getLineInfo(k);
		// k + wrapsize sB
		if( (UINT)start <= p + f.wrapsize() )
		{
			startLine = start- p;
			break;
		}else{
			p += f.wrapsize() + 1;
			startStr++;
		}
	}

	// `
	//left, top, right, bottom
	RECT tr={ r.left+1, r.top, r.right, height};
	String ts;
	for( UINT i=startStr; i<size; i++)
	{
		const String&    s = _doc.getString(i);
		LineInfo&     info = _tool.getLineInfo(i);
		UINT             n = info.wrapsize();

		// ōsԍƊyB
		// łAstartLine  0 łȂȂ珑łB
		if( !(i==startStr && startLine!=0) )
		{
			RECT lr={ 5, tr.top, r.left-1, tr.bottom};
			TCHAR temp[12];
			wsprintf(temp, _T("%4d"), i+1);
			::SetTextColor( hdc, _tool.getColor( PaintTool::TXT ) );
			::SetBkColor( hdc, _tool.getColor( PaintTool::BG ) );
			::ExtTextOut( hdc, lr.left, lr.top, 0, NULL,
				temp, _tcslen(temp), NULL );
		}

		for( UINT j= (i==startStr ? startLine : 0); j<=n; j++ )
		{
			int start = (j==0 ? 0 : info[j-1]);
			int end   = ((j==n || n==0) ? s.size() : info[j]);
			int ssize  = s.w_str().size();

//			String ss = s.w_str().substr( start, end );
			String ss = s.w_str().substr( start, end-start );
/*
#ifdef _DEBUG
			OutputDebugString( ss.c_str() );
			OutputDebugString( _T("\n") );
#endif
*/
			// HDC, , `W, , LineInfo
			textOut( hdc, ss, &tr, 
				((n>=1 && j!=n) ? end-start : ss.w_str().size()),
				info, hscroll );

			// HDC, , `W, ΍s, start, end
			textOutSearch(hdc, ss, &tr, i, start, end, hscroll);

			// HDC, , `W, ΍s, start, end
			textOutSel(hdc, ss, &tr, i, start, end, hscroll);

			RECT er = tr;
			er.left += _tool.getStringWidth( ss, ss.size() ) - hscroll;

			// sȂ炱
			if( i!=size-1 && j==n && _tool.getCtrlMark(3))
				drawEOL(hdc, &er);

			// EOF Ȃ炱
			if( i==size-1 && j==n && _tool.getCtrlMark(4))
				drawEOF(hdc, &er);

			tr.top += height + ls;
			if( tr.top >= r.bottom ) break;
//			if( tr.top+ls+height >= r.bottom ) break;
		}
		if( tr.top >= r.bottom ) break;
//		if( tr.top+ls+height >= r.bottom ) break;

	}

}

//----------------------------------------------------------------
void Painter::textOut(HDC hdc, const String& origStr, 
					  LPRECT rect, int length, const LineInfo& info,
					  int hscroll)
{
	RECT r = *rect;
	String s(origStr.c_str());
	int mode = _tool.getHighlightType();
	DWORD t = 0;
	TCHAR tmp[32];

	if( mode==0 )
	{
		// L[[hȂB
		s = translateTab(s);
		::SetTextColor( hdc, _tool.getColor( PaintTool::TXT ) );
		::SetBkColor( hdc, _tool.getColor( PaintTool::BG ) );
		size_t csize = cutHScrollString( hscroll, s, &r, true );
		s = s.substr( csize, s.size()-csize );
		::ExtTextOutW(hdc, r.left, r.top, 0, &r,
			s.w_str().c_str(), s.w_str().size(), NULL);
		return;
	}
	else
	{
		::SetTextColor( hdc, _tool.getColor( PaintTool::TXT ) );
		::SetBkColor( hdc, _tool.getColor( PaintTool::BG ) );
		// L[[hB

		String ss = translateTab(s);
		r.left -= hscroll;

	t = getTime();

		if( mode==1 )
			textOutCPP( hdc, ss, r, info );
		else
			textOutHTML( hdc, ss, r );

	t = getTime() - t;
	wsprintf(tmp, _T("textOutHTML : %d(msec)\n"), t);
	OutputDebugString(tmp);

   }

}

//----------------------------------------------------------------
void Painter::textOutCPP(HDC hdc, String& s, RECT& rr,
						 const LineInfo& info)
{
	COLORREF ctxt = _tool.getColor( PaintTool::TXT ),
			 ckwd = _tool.getColor( PaintTool::KWD ),
			 ccmt = _tool.getColor( PaintTool::CMT );
	int w = 0;
	RECT r = rr;
	RECT lr; _tool.getLineNumRect( &lr );
	int hscroll = lr.right-r.left;
	r.left = lr.right;

	// ŏ getStringWidth āAr.right ̊O̕
	// ؂Ă܂B

	while( 1 )
	{
		if( s.empty() ) break;
	   	if( 0!=(w=isComment(s, info)) )
			{ ::SetTextColor( hdc, ccmt ); }	
		else if( 0!=(w=isKeyword(s)) )
			{ ::SetTextColor( hdc, ckwd ); }
		else
		{
			w = findKeyword(s);
			::SetTextColor( hdc, ctxt );
			if( w==0 ) break;
		}

		// XN[΍
		int cw=0;
		if( hscroll > 0 )
		{
			cw = cutHScrollString( hscroll, s.substr(0,w), &r );
			hscroll -= _tool.getStringWidth(s,w);
		}

		::ExtTextOutW(hdc, r.left, r.top, 0, &r,
			s.substr(cw, s.size()-cw).c_str(),
			w-cw, NULL);
//			s.w_str().c_str(), w, NULL);

		if( w==(int)s.w_str().size() ) break;

		r.left += _tool.getStringWidth( s, w-cw );
		s = s.substr(w, s.size()-w);
	}
	_endcmt = false;
}

//----------------------------------------------------------------
void Painter::textOutHTML(HDC hdc, String& ss, RECT& rr)
{
	size_t pos = 0;
	int w = 0;
	// ctxt ^OA
	// ccmt ^OOB
	COLORREF ctxt = _tool.getColor( PaintTool::TXT ),
			 ckwd = _tool.getColor( PaintTool::KWD ),
			 ccmt = _tool.getColor( PaintTool::CMT );
	RECT r = rr;
	RECT lr; _tool.getLineNumRect( &lr );
	int hscroll = lr.right-r.left;
	r.left = lr.right;

	DWORD t=0, tt=0;
	TCHAR tmp[32];

	// ŏ getStringWidth āAr.right ̊O̕
	// ؂āA̍ɂȂB
	String s = ss.c_str();
	if( s.size() > 128 )
	{
		for( UINT i=128; i<s.size(); i+=10 )
		{
			if( (UINT)(r.right + hscroll - r.left) < _tool.getStringWidth( s, i ) )
			{ s = ss.substr(0, i); break; }
		}
	}

	bool intag = false;
	while(1)
	{
		if( s.empty() ) break;
		if( intag )
		{

		t = getTime();
			if( s[0]==_T('/') )
			{ w=isKeyword(s.substr(1, s.size()-1));
			  if( w!=0 ) ++w; }
			else
			{ w=isKeyword(s); }
		t = getTime() - t;
		tt += t;
		wsprintf( tmp, _T("K:%d"), t );
		if( t>=3 ) OutputDebugString( tmp );

			if( w!=0 )
			{ ::SetTextColor(hdc, ckwd); }
			else
			{
		t = getTime();
				w = findKeyword(s);
		t = getTime() - t;
		tt += t;
		wsprintf( tmp, _T("F:%d"), t );
		if( t>=3 ) OutputDebugString( tmp );

				size_t wpos = s.find( _T('>') );
				if( wpos<=(UINT)w || (w==0&&wpos!=String::npos) )
					w = wpos, intag=false;
				else 
					if( w==0 ) w = s.w_str().size();

				::SetTextColor(hdc, ctxt);
			}
		}
		else
		{
			pos = s.find( _T('<') );
			if( pos==String::npos ) w=s.w_str().size();
			else                    w=pos+1, intag=true;
			::SetTextColor(hdc, ccmt);
			if( w==0 ) break;
		}
		if( w==0 ) continue;

		// XN[΍
		int cw=0;
		if( hscroll > 0 )
		{
			cw = cutHScrollString( hscroll, s.substr(0,w), &r );
			hscroll -= _tool.getStringWidth(s,w);
		}

		const size_t ssize = s.w_str().size();
		::ExtTextOutW(hdc, r.left, r.top, 0, &r,
			s.substr(cw, s.size()-cw).c_str(),
			w-cw, NULL);
//			s.w_str().c_str(), w, NULL);
		if( w==(int)ssize ) break;

		r.left += _tool.getStringWidth( s, w-cw );
		if( r.left > r.right ) break;
		s = s.substr(w, ssize-w);
	}

#ifdef _DEBUG
//	wsprintf( tmp, _T("TT:%d"), tt );
//	OutputDebugString( tmp );
#endif
}

//----------------------------------------------------------------
void Painter::textOutSpecificArea(HDC hdc, String& ss,
				LPRECT rect, int y, UINT start, UINT end,
				int hscroll, COLORREF txtcolor, COLORREF bkcolor,
				POINT p1, POINT p2)
{
	// s͂ł substr ĂB
	// start, end  substr O s ̈ʒuB
	RECT         r = *rect;
	size_t     len = 0;
	int    xoffset = 0;
	UINT b1, b2;
	String s = ss.c_str();

	// ͈͑IȂ return
	if( p1.y == -1 ) return;
	// n[ƏI[ꏏȂ return
	if( p1.y==p2.y && p1.x==p2.x ) return;
	// n[OȂ return
	if( p1.y > y || (p1.y==y && p1.x>(int)end) )
		return;
	// I[Ȃ return
	if( p2.y < y || (p2.y==y && p2.x<(int)start) )
		return;

	// len 

	// ̍sɎn[ꍇ
	if( p1.y==y && (p1.x>=(int)start && p1.x<=(int)end) )
	{
		// I[ꍇ
		if( p2.y==y && (p2.x>=(int)start && p2.x<=(int)end) )
			len = p2.x - p1.x;
		else
			len =  end - p1.x;

		xoffset = p1.x<(int)start ? 
			0 : _tool.getStringWidth(s, p1.x-start);
		b1 = p1.x - start;
	}
	else
	{	// n[͂Ȃ
		// I[͂
		if( p2.y==y && (p2.x>=(int)start && p2.x<=(int)end) )
			len = p2.x - start;
		else
			len = end - start;
		b1 = 0;
	}

	b2 = s.w_str().size() - b1;

	// translateTab Kv
	String s0 = translateTab( s.w_str().substr(0, b1) );
	String s1 = translateTab( s.w_str().substr(0, b1+len) );
	s = s1.w_str().substr(s0.w_str().size(),
		s1.w_str().size()-s0.w_str().size());

	r.left += xoffset - hscroll;

	// [sԍ荶Ȃ`Ȃ
	RECT lr; _tool.getLineNumRect(&lr);
	if( r.left < lr.right ) return;

	::SetTextColor( hdc, txtcolor );
	::SetBkColor( hdc, bkcolor );
	::ExtTextOutW(hdc, r.left, r.top, 0, &r,
		s.w_str().c_str(), 
		s.w_str().size(), NULL);
}

//----------------------------------------------------------------
void Painter::textOutSel(HDC hdc, String& ss, LPRECT rect,
						 int y, UINT start, UINT end, int hscroll)
{
	// s͂ł substr ĂB
	// start, end  substr O s ̈ʒuB
	POINT p1, p2;
	_tool.getSel(&p1, &p2);

	COLORREF txt = _tool.getColor( PaintTool::BG )==RGB(0,0,0) ?
		RGB(0,0,0) : RGB(255,255,255);
	COLORREF bk  = _tool.getColor( PaintTool::BG )==RGB(0,0,0) ?
		RGB(255,255,255) : RGB(0,0,0);

	textOutSpecificArea(hdc, ss, rect, y, 
		start, end, hscroll, txt, bk, p1, p2);
}

//----------------------------------------------------------------
void Painter::textOutSearch(HDC hdc, String& ss, LPRECT rect,
						 int y, UINT start, UINT end, int hscroll)
{
	// s͂ł substr ĂB
	// start, end  substr O s ̈ʒuB
	POINT p1, p2;
	size_t schsize = _tool.getSearchSize();

	COLORREF txt = RGB(0,0,0);
	COLORREF  bk = RGB(168,255,168);

	for( size_t i=0; i<schsize; i++)
	{
		_tool.getSearch(i, &p1, &p2);
		textOutSpecificArea(hdc, ss, rect, y, 
			start, end, hscroll, txt, bk, p1, p2);
	}
}

//----------------------------------------------------------------
void Painter::drawEOF(HDC hdc, const LPRECT lr)
{
	// sԍGA荶Ȃ珑Ȃ
	RECT r; _tool.getLineNumRect(&r);
	if( lr->left < r.right ) return;

	//[EOF]
	::SetTextColor( hdc, _tool.getColor( PaintTool::CTL ) );
	::SetBkColor( hdc, _tool.getColor( PaintTool::BG ) );
	::ExtTextOut( hdc, lr->left, lr->top, 0, NULL,
		_T("[EOF]"), 5, NULL );
}

//----------------------------------------------------------------
void Painter::drawEOL(HDC hdc, const LPRECT lr)
{
	// sԍGA荶Ȃ珑Ȃ
	RECT r; _tool.getLineNumRect(&r);
	if( lr->left < r.right ) return;

	// "/" - s
	::SetTextColor( hdc, _tool.getColor( PaintTool::CTL ) );
	::SetBkColor( hdc, _tool.getColor( PaintTool::BG ) );
	::ExtTextOut( hdc, lr->left, lr->top, 0, NULL,
		_T("/"), 1, NULL );
}

