
#ifndef _NTP2_SEARCHMAN_H_
#define _NTP2_SEARCHMAN_H_

#include "..\uelib2\uelib.h"
#include "ntpedit\editctrl.h"

using namespace uelib;
using namespace ntpedit;

class SearchManager : public Dialog
{
public:
	SearchManager(NtpEdit& e);
	~SearchManager();

private:
	//@{ Cxgnh //@}
	void onInit();
	void onDestroy();
	bool onOK();
	bool onCancel();
	bool onCommand( UINT cmd, UINT id, HWND ctrl );
//	bool onMessage( UINT msg, WPARAM wp, LPARAM lp );
	void onSearchNext();
	void onSearchPrev();
	void onReplace();
	void onReplaceAll();

private:
	//@{ BƊJnʒuB//@}
	void search(bool bAll=false);
	void replace();
	void replaceAll();
	void searchStrings(const String& s, const POINT& ps);

private:
	//@{ ΏۃGfBbgRg[ //@}
	NtpEdit& _edit;
	//@{ [O]Ȃ true //@}
	bool     _bPrev;
	//@{  //@}
	String   _searchStr, _replaceStr;
};

//-----------------------------------------------
inline void SearchManager::onDestroy()
{
	Dialog::onDestroy();
}

inline bool SearchManager::onOK()
{
	return true;
}

inline bool SearchManager::onCancel()
{
//	::PostMessage( getHwnd(), WM_QUIT, 0, 0L );
	return true;
}

#endif //_NTP2_SEARCHMAN_H_

