#include "stdafx.h"
#include "clipboard.h"
using namespace uelib;

//=========================================================================

Clipboard::Clipboard( HWND owner, bool read )
	: _opened( false )
{
	if( ::OpenClipboard(owner) )
		if( read || ::EmptyClipboard() )
			_opened = true;
		else
			::CloseClipboard();
}

Clipboard::~Clipboard()
{
	if( _opened )
		::CloseClipboard();
}

String Clipboard::getUnicodeText() const
{
	String s;
	// CE蔲Unicode Only
	HANDLE h = getData( CF_UNICODETEXT );
	if( h != NULL )
	{
		const TCHAR* p = static_cast<const TCHAR*>(h);
		s = String(p);
	}
	return s;
}
