
#ifndef _UELIB_FILE_H_
#define _UELIB_FILE_H_

namespace uelib{

//=========================================================================
//@{
//  t@CǍ
//
//	S kilib3rd ̃pNł܂B
//	4GB܂łJȂACE ɂƂĂ
//  ̋Ԃ̂悤Ȃ̂łāB
//  ACE ɂ͂܂t@C}bsO̐񂪂B
//@}
//=========================================================================

class FileR{
public:
	FileR();
	~FileR();

	//@{
	//	J
	//	@param fname t@C
	//	@return Jǂ
	//@}
	bool open( const TCHAR* fname );

	//@{
	//	
	//@}
	void close();

public:
	//@{ t@CTCY //@}
	unsigned long size() const;

	//@{ t@Ce}bvAhX擾 //@}
	const unsigned char* base() const;

private:
	//@{ Rs[֎~IuWFNg //@}
	FileR( const FileR& );
	FileR& operator=( const FileR& );

private:
	HANDLE      _handle;
	HANDLE      _fmo;
	ULONG       _size;
	const void* _basePtr;
};

//-------------------------------------------------------------------------

inline ULONG FileR::size() const
	{ return _size; }

inline const UCHAR* FileR::base() const
	{ return static_cast<const UCHAR*>(_basePtr); }


//=========================================================================
//@{
//	ȈՃt@C
//
//	܂ƂłƂ̂B
//@}
//=========================================================================
class FileW
{
public:

	FileW();
	~FileW();

	//@{ J //@}
	bool open( const TCHAR* fname, bool creat=true );

	//@{  //@}
	void close();

	//@{  //@}
	void write( const void* buf, ULONG siz );

	//@{ ꕶ //@}
	void writeC( UCHAR ch );

public:

	void flush();

private:

	HANDLE      _handle;
	UCHAR*      _buf;
	ULONG       _bPos;
	const int   BUFSIZE;

private:
	//@{ Rs[֎~IuWFNg //@}
	FileW( const FileW& );
	FileW& operator=( const FileW& );

};

//-------------------------------------------------------------------------

} //namespace uelib
#endif // _UELIB_FILE_H_

