
#ifndef _UELIB_REG_H_
#define _UELIB_REG_H_

#include "String.h"

namespace uelib {

//--------------------------
//@{
// WXĝ߂̊NXB
// ɂẴNXgƂ͂ȂB
// Reg NXgƁB
//@}
//--------------------------

class RegKey
{
public:
	RegKey();
	virtual ~RegKey();

public:
	LONG del(HKEY hKeyRoot, LPCTSTR pszPath);
	LONG open (HKEY hKeyRoot, LPCTSTR pszPath);
	void close();
	
	LONG write (LPCTSTR pszKey, DWORD dwVal);
	LONG write (LPCTSTR pszKey, LPCTSTR pszVal);
	LONG write (LPCTSTR pszKey, const BYTE* pData, DWORD dwLength);
	
	LONG read (LPCTSTR pszKey, DWORD& dwVal);
	LONG read (LPCTSTR pszKey, String& sVal);
	LONG read (LPCTSTR pszKey, BYTE* pData, DWORD& dwLength);
	
protected:
	HKEY   _root, _hKey;
	String _sPath;
};

//@{
// Reg NXBł͂pB
//@}

class Reg
{
public:
	Reg(const HKEY r, const String& path);
	virtual ~Reg(){};

public:
	BOOL getBinary(const TCHAR* csSettingName);
	BOOL setBinary(const TCHAR* csSettingName, const BOOL bCode);
	void setString(const TCHAR* csSettingName, const TCHAR* csSetting);
	const String& getString(const TCHAR* csSettingName);
	DWORD getDword(const TCHAR* csSettingName);

private:
	String _path, _out;
	HKEY _root;
};

//------------------------------------------------------
inline Reg::Reg(const HKEY r,
				const String& path)
{ _root = r; _path = path; }

} //namespace uelib
#endif