
#ifndef _UELIB_UTIL_H_
#define _UELIB_UTIL_H_

//#ifdef _WIN32_WCE

namespace uelib{

inline char *CharNextA(const char* a)
{
	char *p=(char*)a;
	if(TRUE==IsDBCSLeadByteEx(CP_ACP, (BYTE)*a))
		p+=2;
	else
		p++;

	return p;
}

inline DWORD GetCurrentDirectory(DWORD buflen, LPTSTR buf)
{
	::GetModuleFileName(NULL, buf, buflen);

	String s = buf;
	size_t pos = s.find_last_of( _T('\\') );

	if( pos==0 )
	{
		_tcscpy( buf, _T("") ); return 0;
	}
	else
	{
		_tcscpy( buf, s.substr( 0, pos ).c_str() );
		return _tcslen( buf );
	}
}

inline int MulDiv(int n, int nn, int nd)
{
//	__int64 i = (__int64)n * (__int64)nn;
//	return (int)( i/(__int64)nd );
	__int64 i = (__int64)n * (__int64)nn;
	__int64 ir= i % nd,
			is= nd/2;
	if( ir >= is )
		return (int)( i/(__int64)nd + 1 );
	else
		return (int)( i/(__int64)nd );
}

inline DWORD getTime()
{
#ifdef _WIN32_WCE
	return ::GetTickCount();
#else
	return ::timeGetTime();
#endif
}

} //namespace uelib

//#endif //WIN32_WCE
#endif //_UELIB_UTIL_H_
