
#include "stdafx.h"
#include <commctrl.h>
#include <commdlg.h>
#ifndef _WIN32_WCE
  #include <shlobj.h>
#endif

#include "..\uelib2\uelib.h"
#include "ntpmain.h"
#include "resource.h"

#include "azdialog.h"

using namespace uelib;
using namespace ntpedit;

bool bParseStart = true;
LPARAM lpLinkBuf=0;

typedef DWORD   (*AZGETURIHTML)(LPCTSTR, TCHAR*, HWND);
typedef size_t  (*AZGETSIZE)(LPCTSTR, HWND);
typedef int     (*AZGETTYPE)(LPCTSTR, HWND);
typedef bool    (*AZSTOP)(HWND, DWORD);
typedef bool    (*AZCLOSE)(HWND, DWORD);
typedef bool    (*AZCLOSEDATA)(HWND, DWORD, bool);
typedef bool    (*AZUPDATE)(DWORD);
typedef void    (*AZSETVALUE)(int);
typedef int     (*AZGETVALUE)();
typedef void    (*AZCLEARREDIRECT)();

AzDialog*   dd=NULL; // HTML parse i
AzDialog*   wd=NULL; // ŏ "҂Ă܂"
AzDLDialog* dl=NULL; // _E[hi
String      ps;      // pending p
//----------------------------------------------------

void Ntp::onOpenURI(const TCHAR* uri)
{
	AZGETURIHTML f = (AZGETURIHTML)getProcAddress( _hDLL,
		_T("AZGetURIHTML") );
	if ( !f ) return;

	// POST or GET ̏ꍇ͏
	String getstr = _T("");
	if( 0==_tcsncmp( uri, _T("POST;"), 5 ) || 0==_tcsncmp( uri, _T("GET;"), 4 ) )
	{
		int len = _tcslen( uri );

		// submit  post s
		if( 0==_tcsicmp( uri+len-6, _T("submit") ) )
		{
			// GET ̏ꍇ URI ̌Ƀf[^邾
			if( 0==_tcsncmp( uri, _T("GET;"), 4 ) )
				getstr = getGetString( uri );
			else
			{
				onOpenURI_POST( uri );
				return;
			}
		}
		else
		{
			// ȊOȂ_CAOo
			AzTxtDialog a( uri, _mform, _mform[String(uri)] );
			a.doModal( getHwnd() );
			return;
		}
	}

	// ]~߂
	if( dd!=NULL )
	{
		if( !ps.empty() ) return;
		onStopURI();
		if( 0==_tcscmp( uri, _T("") ) )
		{
			// 󂾂R{{bNX
			int len = SendMessage( _hCombo, WM_GETTEXTLENGTH, 0, 0L );
			TCHAR* uritmp = new TCHAR[len+2];
			::GetWindowText( _hCombo, uritmp, len+1 );
			ps = uritmp;
			delete [] uritmp;
		}else{
			ps = uri;
		}
		return;
	}

	// ŏ"҂Ă܂"\
	if( wd!=NULL ) delete [] wd;
	wd = new AzDialog( 0, 1024, 0 );
	wd->doModeless( getHwnd() );
	RECT r;
	::GetWindowRect( getHwnd(), &r );
#ifdef _WIN32_WCE
	int height = CommandBar_Height( _hwndCB );
#else
	int height = 0;
#endif
	wd->moveTo( r.right-200, height+1, r.right-22, height+26 );
	wd->show(); wd->update();

	// t@C擾
	String s = uri;
	if( 0==ps.compare( uri ) ) ps=_T("");

	TCHAR *uritmp=NULL;
	if( s.empty() )
	{
		// ɉnȂR{{bNX擾
		int len = SendMessage( _hCombo, WM_GETTEXTLENGTH, 0, 0L );
		uritmp = new TCHAR[len+2];
		::GetWindowText( _hCombo, uritmp, len+1 );
		s = uritmp;
	}

	// GET M getstr ɒlĂ̂
	// ƍւ
	if( !getstr.empty() ) s = getstr;

	// ̎_ uri ȂI
	if( s.empty() )
	{
		wd->end(0); delete wd; wd=NULL;
		delete [] uritmp; return; 
	}

	// _~[
//	s = _T("file:///My Documents/a.html");
//	s = _T("file://a.html");
//	s = _T("file://uebbs.html");
//	s = _T("http://hp.vector.co.jp/authors/VA023546/index.html");
//	s = _T("http://hp.vector.co.jp/authors/VA017441/tlk/");
//	s = _T("http://a.hatena.ne.jp/go?http://530.teacup.com/int/bbs");
//	s = _T("http://www.faireal.net/");

	// JgfBNgۑ
	setCurrentURI( s );

	Ini ini(0);
	ini.open( _T("n12k2.ini") );
	int n = ini.readInt( _T("Azukimochi"),
		_T("ShowFileSize") );

	size_t size=0;
	if( n==1 )
	{
		// URI ̃t@CTCY擾
		AZGETSIZE fs = (AZGETSIZE)getProcAddress( _hDLL,
			_T("AZGetURIFileSize") );
		size = fs( s.c_str(), getHwnd() );
	}

	// HTTP_QUERY_CONTENT_TYPE ŃeLXgǂmFH
	AZGETTYPE ft = (AZGETTYPE)getProcAddress( _hDLL,
			_T("AZGetContentType") );
	int type = 0;
	if( ft ) type = ft( s.c_str(), getHwnd() );

	if( type==-1 )
	{
		::MessageBox( getHwnd(), 
			_T("T[o[Ƃ̌MɎs܂\n")
			_T("GetContentType Failed.\n"),
			_T("n12k2 Azukimochi-mode"), MB_ICONSTOP);
		wd->end(0); delete wd; wd=NULL;
		delete [] uritmp;
		return;
	}

	// ܂ԂZbg
	AZSETVALUE fv = (AZSETVALUE)getProcAddress( _hDLL,
			_T("AZSetLineWidth") );

	if( fv )
	{
		int nn = ini.readInt( _T("Azukimochi"),
		_T("LineWidth") );
		fv(nn);	
	}

	DWORD id;
	if( type==0 )
	{
		// ǂ
		id = f( s.c_str(), _buf, getHwnd() );

		wd->end(0); delete wd; wd=NULL;

		initAZDialog( size, id );
	}
	else
	{
		// _E[h͈xɈ
		wd->end(0); delete wd; wd=NULL;
		if( dl==NULL )
			downloadFile( s, size );
		else
			::MessageBox( getHwnd(), 
				_T("2 ȏ㓯Ƀ_E[hł܂"), 
				_T("n21k2 Azukimochi-mode"), MB_ICONSTOP );
	}

	// HTML Ȃ痚c
	if( type==0 )
	{
		if( _cpos < (int)_vhistory.size()-1 )
		{
			if( 0!=_vhistory[_cpos].compare(s) )
			{
				// O̗폜Ēǉ
				vector<String>::iterator itr = _vhistory.begin();
				for( int i=0; i<=_cpos; i++ ) ++itr;
				_vhistory.erase( itr, _vhistory.end() );
				_vhistory.push_back( s ), _cpos++;
			}
		}
		else
		{
			// ӂ[ɒǉ
			if( _cpos==-1 || 0!=_vhistory[_cpos].compare(s) )
				_vhistory.push_back( s ), _cpos++;
		}
		::SendMessage( _hCombo, CB_INSERTSTRING, 0,
			(LPARAM)s.c_str() );
		::SetWindowText( _hCombo, s.c_str() );
	}

	delete [] uritmp;
}

void Ntp::onHTMLUpdated(WPARAM wp, TCHAR* buf)
{
	AZUPDATE f = (AZUPDATE)getProcAddress( _hDLL,
		_T("AZUpdateData") );

	if( !f ) return;

	// wp  1 ̂Ƃ́H
	if( wp==1 )
	{
		if( dl!=NULL )
		{
			dl->do_increment();
			dl->update();
			f( dl->id() );
		}
		return;
	}

	// ȂȂɂȂ
	if( 0==_tcscmp(buf, _T("") ) )
	{
		dd->do_increment(); dd->update();
		f( dd->id() );
		return;
	}

	// ȉA EditCtrl ɑ
	::EnterCriticalSection(&_cs);
/*
	if( 0==_tcscmp(buf, _T("") ) )
	{
		dd->do_increment(); dd->update();
		f( dd->id() );
		::LeaveCriticalSection(&_cs);
		return;
	}
*/
	TxtDecoder2 dec( UTF16LE );
	dec.open( (const unsigned char*)buf,
		_tcslen(buf)*sizeof(TCHAR) );
	_e.getDoc().read( dec, 
		bParseStart==true ? true : false );

	//  link  PaintTool ɓo^B
	sendLinkPos( bParseStart );

	PaintTool& t = _e.getPaintTool();
	t.updateWrapInfo();

	if( bParseStart )
	{
		_e.getView().getCaret().reset();
		_e.getView().getScroll().reset();
	}

	_e.getView().getScroll().onSize( 
		t.getLines(), t.getTotalLines() );

//	++dd;
	dd->do_increment();
	dd->update();

	f( dd->id() );

	bParseStart = false;

	::LeaveCriticalSection(&_cs);
}

void Ntp::onHTMLParseEnd(WPARAM wp)
{
	// wp=0 : HTMLParse, 1=Data, -1:All
	DWORD dwID = 0;

	// f[^_E[h̃X~߂
	if( dl!=NULL && (wp==1 || wp==-1) )
	{
		bool vflag = dl->viewflag();
		String fname = dl->fname();
		dwID=dl->id(); dl->end(0);
		delete dl; dl=NULL;

		AZCLOSEDATA fd = (AZCLOSEDATA)getProcAddress( _hDLL,
			_T("AZCloseDataThread") );

		if( fd ) fd( getHwnd(), dwID, false );
		Sleep(100);
		if( fd ) fd( getHwnd(), dwID, true );

		if( wp==1 && vflag )
		{
			Ini ini(0);
			ini.open( _T("n12k2.ini") );
			String s = ini.readString( _T("Azukimochi"),
				_T("ImageViewer") );
			_vimage.push_back( fname );
			s += _T(" \""); s += fname; s += _T("\"");
			PROCESS_INFORMATION pi;
			::CreateProcess(s.c_str(), NULL, 
				NULL, NULL, NULL, 0, NULL, NULL, NULL, &pi );
			::CloseHandle(pi.hThread);
			::CloseHandle(pi.hProcess);
			return;
		}
	}

	bParseStart = true;

	//  link  PaintTool ɓo^B
	sendLinkPos();

	// _mlink ͈ꎞIȂ̂Ȃ̂
	// clear قˁB
//	_mlink.clear();
	lpLinkBuf = 0;

	// HTML Parser ̃X~߂
	if( dd!=NULL )
	{
		dwID=dd->id(); dd->end(0);
		delete dd; dd=NULL;

		AZCLOSE f = (AZCLOSE)getProcAddress( _hDLL,
			_T("AZCloseThread") );

		if( f ) f( getHwnd(), dwID );

		if( !ps.empty() )
			onOpenURI( ps.c_str() );
	}
}

void Ntp::onHTMLLink(LPARAM lp)
{
	// ł PaintTool ɓ悤ƂĂ
	// Bʂ̕񂪑ĂĂȂB

	// ̂Ƃ WM_LINKURI Ă̂
	// ̂Ƃ map ɓB
	if( lpLinkBuf==0 ) lpLinkBuf = lp;
}

void Ntp::onHTMLLinkURI(LPARAM lp)
{
	// ł󂯎f[^
	// _mlink ɕۑB
	String s = (TCHAR*)lp;

	_mlink.insert( pair<LPARAM, String>(lpLinkBuf, s) );
	lpLinkBuf = 0;
}

void Ntp::onHTMLGetURI(LPARAM lp)
{
	// N̕NbNꂽA
	// Painter 炱̃bZ[W
	// łB
	String s = (TCHAR*)lp;

	// mailto: Ȃ烁[[N
	if( 0==s.find( _T("mailto:") ) )
	{
		PROCESS_INFORMATION pi;
		::CreateProcess(s.c_str(), NULL, 
			NULL, NULL, NULL, 0, NULL, NULL, NULL, &pi );
		::CloseHandle(pi.hThread);
		::CloseHandle(pi.hProcess);
		return;
	}

	onOpenURI( s.c_str() );
}

void Ntp::onHTMLRedirect(LPARAM lp)
{
	AZCLEARREDIRECT f = (AZCLEARREDIRECT)getProcAddress( _hDLL,
		_T("AZClearRedirectURI") );

	if ( !f ) return;
	
	String s = (const char*)lp;
	f();
	ps = s;
	onStopURI();
}

void Ntp::onBackURI()
{
	// ߂
	if( _cpos<=0 ) return;
	::SetWindowText( _hCombo, _vhistory[--_cpos].c_str() );
	onOpenURI();
}

void Ntp::onNextURI()
{
	// i
	if( _cpos >= (int)_vhistory.size()-1 ) return;
	::SetWindowText( _hCombo, _vhistory[++_cpos].c_str() );
	onOpenURI();
}

void Ntp::onStopURI()
{
	// ~
	if( dd==NULL ) return;

	// _CAO[~]Əo
	dd->do_stop(); 
	dd->update();

	AZSTOP f = (AZSTOP)getProcAddress( _hDLL,
		_T("AZStopThread") );

	if( f ) f( getHwnd(), dd->id() );
}

void Ntp::onReloadURI()
{
	// XV
	onOpenURI();
}

void Ntp::onBookmarkURI(HWND h)
{
	RECT r;
	::GetWindowRect(h, &r);
	r.left += 80;

	_mbookmark.clear();

	// j[
	HMENU hMenu = ::CreatePopupMenu();
	::AppendMenu(hMenu, MF_STRING, 39998, _T("ǉ") );
	::AppendMenu(hMenu, MF_STRING, 39999, _T("") );
	::AppendMenu(hMenu, MF_SEPARATOR, -1, NULL );

	// .url ǂ
	TCHAR path[MAX_PATH*2];
	getBookmarkDirectory( path );
	_tcscat( path, _T("\\*.*") );
	createBookmarkMenu( path, hMenu, 30001 );

	// \
	::TrackPopupMenu(hMenu, TPM_LEFTALIGN,
		r.left, r.bottom, 0, getHwnd(), NULL);
	::DestroyMenu(hMenu);
}

void Ntp::onEncodeURI(HWND h)
{
	RECT r;
	::GetWindowRect(h, &r);
	r.left += 125;

	// GetEncode Ō݂̃GR[h擾
	AZGETVALUE f = (AZGETVALUE)getProcAddress( _hDLL,
		_T("AZGetCharset") );
	if ( !f ) return;

	HMENU hmenu = ::LoadMenu(_hInst,
		MAKEINTRESOURCE(IDR_MENU_ENCODE));
	HMENU hSubmenu = ::GetSubMenu(hmenu, 0);

	UINT code;
	switch( f() )
	{
	case 0:
		code = IDM_ENCODE_AUTO; break;
	case EucJP:
		code = IDM_ENCODE_EUC; break;
	case IsoJP:
		code = IDM_ENCODE_JIS; break;
	case SJIS:
		code = IDM_ENCODE_SJIS; break;
	case UTF8N:
		code = IDM_ENCODE_UTF8; break;
	}
	::CheckMenuRadioItem( hSubmenu, IDM_ENCODE_AUTO,
		IDM_ENCODE_UTF8, code, MF_BYCOMMAND );

	::TrackPopupMenu(hSubmenu, TPM_LEFTALIGN,
		r.left, r.bottom, 0, getHwnd(), NULL);
	::DestroyMenu(hmenu);
}

void Ntp::onNotify(WPARAM wp, LPARAM lp)
{
	// R}hoh𓮂ƂȂ񂩂̏B
	LPNMHDR pnmh; 
	pnmh = (LPNMHDR)lp;
	RECT rc, rcp;
	int width;
	switch( pnmh->code )
	{
	case RBN_LAYOUTCHANGED:
		// R{{bNXTCY
		::GetWindowRect(_hCombo, &rc);
		::GetWindowRect( GetParent(_hCombo), &rcp );
		width = rcp.right - rcp.left;
		::SetWindowPos(_hCombo, HWND_TOP, 0, 0, 
			width-10, rc.bottom-rc.top,
			SWP_NOZORDER);
		return;
	case RBN_HEIGHTCHANGE:
		{
//		int h=CommandBar_Height(_hwndCB);
		RECT r;
		::GetWindowRect( getHwnd(), &r );
		::SendMessage( getHwnd(), WM_SIZE, 0, 
			r.right|(r.bottom<<16) );
		}
		return;
	}
}


