

#include "stdafx.h"
#include <commctrl.h>
#include <commdlg.h>
#ifndef _WIN32_WCE
  #include <stdio.h>
  #include <shlobj.h>
#endif

#include "..\uelib2\uelib.h"
#include "ntpmain.h"
#include "resource.h"

#include "azdialog.h"

using namespace uelib;
using namespace ntpedit;

typedef DWORD (*AZGETURIPOSTHTML)(LPCTSTR, LPCSTR, TCHAR*, HWND);

extern AzDialog*   dd; // HTML parse i

//-------------------------------------------------------

void Ntp::onOpenURI_POST(const TCHAR* uri)
{
	AZGETURIPOSTHTML f = (AZGETURIPOSTHTML)getProcAddress( _hDLL,
		_T("AZGetURIPostHTML") );

	if ( !f ) return;

	// ]~߂
	if( dd!=NULL ) onStopURI();

	// submit ̃AhXA_mform T
	// POST ׂ擾
	char* lpPost = getPostString( uri );

	// AhX؂
	String uristr = uri;
	size_t n = uristr.find( _T(';') );
	uristr = uristr.substr( n+1, uristr.size()-(n+1) );
	n = uristr.find( _T(';') );
	uristr = uristr.substr( 0, n );

	// POST ̃AhX΃AhX
	// ΃AhXɕύX
	if( uristr.substr( 0, 4 ) != _T("http") )
	{
		uristr = _cdir + uristr;
	}

#ifdef _DEBUG
	OutputDebugStringA( lpPost );
	OutputDebugStringW( _T("\n") );
	OutputDebugStringW( uristr.c_str() );
	OutputDebugStringW( _T("\n") );
#endif

	// POST MX
	DWORD id = f( uristr.c_str(), lpPost, _buf, getHwnd() );

	// i󋵃_CAOo
	initAZDialog(0, id);

	delete [] lpPost;
}

//-------------------------------------------------------
char* Ntp::getPostString( const TCHAR* uri )
{
	String us=uri, s=_T("");

	// uri  POST;uri ̌`ɐ؂
	size_t un = us.find_last_of( _T(';') );
	us = us.substr( 0, un );

	map<String, String>::iterator itr    = _mform.begin();
	map<String, String>::iterator itrEnd = _mform.end();

	for( ; itr!=itrEnd; ++itr )
	{
		String is = itr->first;
		// first = POST;uri;name
		size_t n = is.find_last_of( _T(';') );

		// POST;uri 
		if( is.substr( 0, n ) == us )
		{
			// s  name=itr->second& ǉ
			s += is.substr( n+1, is.size()-(n+1) );
			s += _T("=");
			s += encodeURI( itr->second );
			s += _T("&");
		}
	}

	// Ō & ͗]v
	if( !s.empty() )
		s = s.substr( 0, s.size()-1 );

	// TCHAR -> char
	char *p = new char[s.size()+2];
	::WideCharToMultiByte(CP_ACP, 0, s.c_str(),
		-1, p, s.size()+1, NULL, NULL );

	_mform.clear();

	return p;
}

//-------------------------------------------------------
String Ntp::encodeURI(const String& in)
{
	String s = _T("");
	char tmp[12]={0};

	// TCHAR -> char
	int length = ::WideCharToMultiByte(CP_ACP, 0, in.c_str(),
		-1, NULL, 0, NULL, NULL );
	char *p = new char[length+1];
	::WideCharToMultiByte(CP_ACP, 0, in.c_str(),
		-1, p, length, NULL, NULL );

	for (int i=0; i<length-1; i++ )
	{
		if( (p[i] >= '0' && p[i] <= '9') ||
			(p[i] >= 'A' && p[i] <= 'Z') ||
			(p[i] >= 'a' && p[i] <= 'z') ||
			p[i]=='_' || p[i]=='-' || 
			p[i]=='.' || p[i]=='*' )
			tmp[0] = p[i], tmp[1]='\0';
		else if( p[i]==' ' )
			tmp[0] = '+', tmp[1] = '\0';
		else
		{
			sprintf(tmp, "%%%02X", (unsigned char)p[i] );
		}
		s += tmp;
	}

	delete [] p;
	return s;
}

//-------------------------------------------------------

String Ntp::getGetString( const TCHAR* uri )
{
	String us = uri, s=_T("");

	// uri = GET;uri;submit

	// uri  GET;uri ؂
	size_t un = us.find_last_of( _T(';') );
	us = us.substr( 0, un );

	// iterator ŕĂ
	map<String, String>::iterator itr    = _mform.begin();
	map<String, String>::iterator itrEnd = _mform.end();
	for( ; itr!=itrEnd; ++itr )
	{
		String is = itr->first;
		// first = GET;uri;name
		size_t n = is.find_last_of( _T(';') );

		// GET;uri 
		if( is.substr( 0, n ) == us )
		{
			// s  name=itr->second& ǉ
			s += is.substr( n+1, is.size()-(n+1) );
			s += _T("=");
			s += encodeURI( itr->second );
			s += _T("&");
		}
	}

	// URI ̌ɂ
	un = us.find( _T(';') );
	us = us.substr( un+1, us.size()-(un+1) );

	if( !s.empty() )
	{
		// URI ̖ ? 
		us += _T("?");
		// ̍Ō & ͂Ȃ
		s = s.substr( 0, s.size()-1 );
		// URI Ƃ
		s = us + s;
	}

	_mform.clear();

	return s;
}

void Ntp::getFormHidden( const String& s )
{
	// hidden ̏ꍇALPARAM  -1 ̃N𑗂
	// POST;uri;name;hidden;value ̏B

	// name ̌ ; TĂ̑O܂Ő؂
	size_t n = s.find( _T(';'), 0 );
	n = s.find( _T(';'), n+1 );
	n = s.find( _T(';'), n+1 );
	String s1 = s.substr( 0, n );

	// value ؂
	n = s.find_last_of( _T(';') );
	String s2 = s.substr( n+1, s.size()-(n+1) );

	// POST;uri;name  value  _mform  insertB
	_mform.insert( pair<String, String>(s1, s2) );
}

