
#ifndef _UELIB_CMDARG_H_
#define _UELIB_CMDARG_H_

#include <vector>
#include "string.h"

namespace uelib{

//@{
//  R}hCp[TB
//  CX^X𐶐ĕ悵A
//  static  getCommandLine ŕ𓾂悵B
//  (CE ɂ GetCommandLine Ȃ)
//@}
class Argv
{
public:
	Argv();
	~Argv();

public:
	//@{ 󂯎 //@}
	static void setCmdLine( LPSTR s );
	//@{ 󂯎 //@}
	static void setCmdLine( LPWSTR s );
	//@{ 擾 //@}
	static const TCHAR* getCmdLine();

public:
	//@{ Get //@}
	const TCHAR* operator[]( ULONG i ) const;
	//@{ TCYGet //@}
	size_t size() const;

private:
	//@{ R}hC̕ //@}
	void parse();

private:
	//@{ ̂̕܂ܕێ //@}
	static String _cmdLine;
	//@{ ̕i[ vector //@}
	vector<String> _vArgv;
};

//---------------------------------------------------------
inline Argv::Argv()
	{ parse(); }

inline Argv::~Argv()
	{}

inline void Argv::setCmdLine( LPSTR s )
	{ _cmdLine = s; }

inline void Argv::setCmdLine( LPWSTR s )
	{ _cmdLine = s; }

inline const TCHAR* Argv::getCmdLine()
	{ return _cmdLine.c_str(); }

inline size_t Argv::size() const
	{ return _vArgv.size(); }

inline const TCHAR* Argv::operator[]( ULONG i ) const
	{ return _vArgv[i].c_str(); }

} //namespace uelib
#endif // _UELIB_CMDARG_H_
