
#include "stdafx.h"
#include "string.h"

using namespace uelib;


String::~String()
{
	if( _p != NULL ){
		delete [] _p;
		_p = NULL;
	}
}

String& String::operator=(const char *a)
{
	if( _p != NULL ){ delete [] _p; _p = NULL; }
	*this = wstr( a );
	return *this;
}

String& String::operator=(const string& s)
{
	if( _p != NULL ){ delete [] _p; _p = NULL; }
	*this = wstr( s.c_str() );
	return *this;
}

String& String::operator=(const wstring& s)
{
	if( _p != NULL ){ delete [] _p; _p = NULL; }
	wstring::operator=(s);
	return *this;
}

String& String::operator=(const String& s)
{
	if( _p != NULL ){ delete [] _p; _p = NULL; }
	wstring::operator=(s.w_str());
	return *this;
}

String& String::operator += ( const TCHAR *a )
{
#ifdef UNICODE
	*this = wstring::operator+=( a );
#else
	*this = wstring::operator+=( wstr(a) );
#endif
	return *this;
}

String& String::operator += ( const String& s )
{
	*this = wstring::operator+=( s );
	return *this;
}

size_t String::findi( const String& cs ) const
{
	// 啶ʂȂ findB
	// new/delete ALocalAlloc/LocalFree ̂ق
	// 낤ƎvĎĂ݂Aʂ
	// {ȏLocalAlloĉقxBӊOB
	size_t   size = wstring::size();
	size_t cssize = cs.size();

	// ̕Aôׂق񂶂
	// v悤ȂI
	if( size < cssize ) return wstring::npos;

	wchar_t *w = new wchar_t[ size+1 ];
//	wchar_t *w  = (wchar_t*)::LocalAlloc(LPTR, 
//		(size+1)*sizeof(wchar_t) );
	wcscpy( w, w_str().c_str() );
	wchar_t *cw = new wchar_t[ cssize+1 ];
//	wchar_t *cw = (wchar_t*)::LocalAlloc(LPTR, 
//		(cssize+1)*sizeof(wchar_t) );
	wcscpy( cw, cs.w_str().c_str() );

	wchar_t *p=w, *cp=cw;
	for(size_t i=0; i<size-cssize+1; )
	{
		size_t j=0;
		for( j=0; j<cssize; j++ )
		{
//			wchar_t t1 = (*this)[i+j], t2=0;
//			wchar_t ts = cs[j];
			wchar_t t1 = p[j], t2=0;
			wchar_t ts = cp[j];

			// 啶Ȃ珬, Ȃ啶
			if( t1>=0x41 && t1<=0x5A )      t2 = t1+0x20;
			else if( t1>=0x61 && t1<=0x7A ) t2 = t1-0x20;
			else                            t2 = t1;

			if( t1!=ts && t2!=ts )
				break;
		}
		if( j==cssize ){ delete [] w; delete [] cw; return i; }
//		if( j==cssize ){ ::LocalFree(w); ::LocalFree(cw); return i; }
		i+=j+1, p+=j+1;
	}
	delete [] w; delete [] cw;
//	::LocalFree(w); ::LocalFree(cw);
	return wstring::npos;
}

const TCHAR* String::c_str(void) const
{
#ifdef UNICODE

	// ̂܂܏o
	return wstring::c_str();

#else //UNICODE

	// char ɕϊďo
	// GA
	// CE Ŏs邱Ƃ͂قڂȂ̂
	// ܂悵ƂB
	string a = astr( wstring::c_str() );

	char *p = new char[ strlen( a.c_str() )+1 ];
	strcpy( p, a.c_str() );

	if( _p != NULL ){ 
//		delete [] _p;
		delete [] const_cast<char*>(_p);
		const_cast<char*>(_p) = NULL;
	}
	const_cast< char* >(_p) = p;

	return _p;

#endif //UNICODE
}

const string String::a_str(void) const
{
#ifdef UNICODE
	return astr( c_str() );
#else
	return string( c_str() );
#endif
}

const wstring String::w_str(void) const
{
#ifdef UNICODE
	return wstring( c_str() );
#else
	return wstr( c_str() );
#endif
}

string String::astr(const wchar_t* w) const
{
	DWORD charlength = WideCharToMultiByte(CP_ACP, 0,
				w,-1, 
				NULL, 0, NULL, NULL);
	char* pChar = new char [charlength+1];
	WideCharToMultiByte(CP_ACP, 0, w,
		-1, pChar, charlength, NULL, NULL);
	string s = pChar;
	delete [] pChar;
	return s;
}

wstring String::wstr(const char *a) const
{
	int length = MultiByteToWideChar(CP_ACP, 0, 
		a, -1,
		NULL, 0);
	wchar_t *w_buf = new wchar_t[length+1];
	MultiByteToWideChar(CP_ACP, 0,
		a, -1,
		w_buf, length);
	wstring w = w_buf;
	delete [] w_buf;
	return w;
}

